SystemOrganization addCategory: #GeoDSL!
SystemOrganization addCategory: #'GeoDSL-Examples'!

BorderedMorph subclass: #GeoDSLCar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!GeoDSLCar commentStamp: '<historical>' prior: 0!
A GeoDSLCar is a Morph.

Any GeoDSL morph must be created using Morph>>newBounds:
The private morph method privateBounds: must be complemented to construct the morph



!

!GeoDSLCar methodsFor: 'initialize-release' stamp: 'hk 1/26/2014 13:14'!
initializeMorph
	"construct a car"
	| wheel |
	self borderWidth: 2.
	self color: Color red.  "Ferrari"
	self useRoundedCorners.
	wheel := Rectangle origin: self bounds origin extent: self bounds extent / 7.
	self addMorph: ((Morph newBounds: wheel) center: self bounds origin + (3@0 * self width / 14); color: Color black).
	self addMorph: ((Morph newBounds: wheel) center: self bounds origin + (11@0 * self width / 14); color: Color black).
	self addMorph: ((Morph newBounds: wheel) center: self bounds corner - (3@0 * self width / 14); color: Color black).
	self addMorph: ((Morph newBounds: wheel) center: self bounds corner - (11@0 * self width / 14); color: Color black).! !

!GeoDSLCar methodsFor: 'private' stamp: 'hk 1/27/2014 16:37'!
privateBounds: boundsRect
	"bounds cannot be set at initialization time, thus we must intercept this morph method"
	super privateBounds: boundsRect.
	self initializeMorph
! !

PPCompositeParser subclass: #GeoDSLGrammar
	instanceVariableNames: 'identifier integer point pointArray anyObject poly polygon polyline object graphics size location bearing label labelString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLGrammar commentStamp: '<historical>' prior: 0!
A GeoDSLGrammar for PetitParser!

GeoDSLGrammar subclass: #GeoDSLCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLCompiler commentStamp: '<historical>' prior: 0!
A GeoDSLCompiler for PetitParser
!

!GeoDSLCompiler class methodsFor: 'as yet unclassified' stamp: 'hk 1/14/2014 12:04'!
startSymbol
	"Answer the method that represents the default start symbol."

	^ #geoDSL! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/27/2014 17:08'!
anyObject
	^ super anyObject ==> [:n | n at: 2 ] 
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/21/2014 16:35'!
bearing
	^ super bearing ==> [:n | n ifNil: [0 ] ifNotNil: [(n at: 2) inputValue asNumber degreesToRadians] ]
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/23/2014 13:04'!
graphics
	^ super graphics
		==> [:n | | r  |  (n at: 4) isEmpty  ifTrue: [  r := PPFailure message: 'no objects' at: 0  ]
				 ifFalse: [r := GeoDSLDrawing new: (n at: 2) inputValue.
						(n at: 4) do: [ :e | r  addToObjectDict:  e ]. 
						r createAllMorphsWithin: (n at: 3). ].	
				r ] 
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/26/2014 14:13'!
label
	^ super label ==> [:n | n ifNil: [ '' ] ifNotNil: [n at: 2 ] ]
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/26/2014 14:13'!
labelString
	^ super labelString ==> [ :n | n inputValue copyReplaceAll: '_' with: ' ' ]
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/15/2014 11:54'!
location
	^ super location ==> [:n | n at: 2] 
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/27/2014 17:08'!
object
	^ super object
		==> [:n | (GeoDSLObject new)
					morphClass:  (n at: 1) inputValue asSymbol;
					name:  (n at: 2) inputValue;
					size:  (n at:  3);		"migth still be nil"
					location:  (n at: 4);
					bearing:  (n at: 5);
					label:  (n at: 6);
					yourself ] 
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/15/2014 12:13'!
point
	^ super point ==> [:n | Point x: (n at: 1) inputValue asInteger y: (n at: 3) inputValue asInteger]! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/16/2014 10:19'!
pointArray
	^ super pointArray
		==> [:n | |a| Array with: (n at: 2) withAll: (n at: 3)]  ! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/23/2014 12:56'!
poly
	^ super poly
		==> [:n | (GeoDSLPathshape vertices: (n at: 2)) 
					name: (n at: 1) inputValue;
					bearing: (n at: 3);
					label: (n at: 4);
				 	yourself]! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/20/2014 17:09'!
polygon
	^ super polygon ==> [:n | (n at: 2) 
								morphClass: #PolygonMorph;
				 				closed: true;
				 				yourself]! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/20/2014 17:09'!
polyline
	^ super polyline ==> [:n | (n at: 2) 
								morphClass: #PolygonMorph;
				 				closed: false;
								yourself]! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/20/2014 14:23'!
size
	^ super size ==> [:n | n ifNil: [100@100 ] ifNotNil: [n at: 2] ]  ! !

!GeoDSLGrammar class methodsFor: 'as yet unclassified' stamp: 'hk 1/14/2014 12:05'!
compile:  aSpec
	^self parse: aSpec onError: [:msg :pos | self error: (msg, ' at: ', pos printString)]! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/27/2014 17:09'!
anyObject
	^ ($( asParser , (polygon / polyline / object) trim , $) asParser ) trim! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/19/2014 19:23'!
bearing
	^ ( 'bearing:' asParser, integer ) optional ! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/14/2014 13:00'!
comment
	^ ($" asParser , (PPPredicateObjectParser anyExceptAnyOf: '"') star, $" asParser)  token! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/16/2014 10:47'!
geoDSL
	^ graphics end! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/27/2014 17:12'!
graphics
	^ 'displayIn:' asParser trim , identifier , size, anyObject star! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/14/2014 20:40'!
identifier
	^ (#letter asParser , #word asParser star) token trim! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/15/2014 14:54'!
integer
	^ ($- asParser optional, #digit asParser, #digit asParser star ) token trim! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/26/2014 13:40'!
label
	^ ( 'label:' asParser , labelString ) optional ! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/26/2014 13:39'!
labelString
	^ (#letter asParser , (#word asParser | $_ asParser) star) token trim! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/15/2014 11:51'!
location
	^  'at:' asParser , point ! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/27/2014 17:10'!
object
	^ identifier , identifier ,size ,  location , bearing , label ! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/15/2014 18:02'!
point
	^ integer, $@ asParser, integer ! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/16/2014 10:21'!
pointArray
	"contains at least 2 points for polylines and polygons"
	^ ($[ asParser, point, point plus, $] asParser ) trim! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/23/2014 12:55'!
poly
	"PolygonMorph will be used for polygons as well as polylines"
	^ identifier, pointArray, bearing, label! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/16/2014 10:33'!
polygon
	^ 'polygon:' asParser, poly! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/16/2014 10:34'!
polyline
	^ 'polyline:' asParser, poly! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/19/2014 19:22'!
size
	^  ('size:' asParser, point) optional! !

Object subclass: #GeoDSLDrawing
	instanceVariableNames: 'realBounds screenBounds zoom translation objectDict canvas title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLDrawing commentStamp: '<historical>' prior: 0!
A GeoDSLDrawing holds all GeoDSLObjects.
It facilitates the coordinate transforms.

interface methods allow to add, remove and move objects (using their realWorld coordinates)

Instance Variables
	canvas:			<Morph>		- the morph that contains all other morphs
	objectDict:		<Dictionary>	- of all the named graphis objects
	realBounds:	<Rectangle>	- bounds of all objects in rela world
	screenBounds:	<Rectangle>	- bounds of all screen objects
	zoom:			<Number>		- scale of screen / realWorld
	translation:		<Object>		- of realWorld to screen (at 0@0)
	title:			<String>		- for transport from DSL-text to the window
!

!GeoDSLDrawing class methodsFor: 'instance creation' stamp: 'hk 1/20/2014 14:33'!
new: aString 
 	^self new initialize: aString! !

!GeoDSLDrawing methodsFor: 'interface' stamp: 'hk 1/28/2014 16:52'!
add: aGeoDSLObject
	"add an already existing GeoDSLObject"
	
	self addToObjectDict: aGeoDSLObject.
	self resetZoom.	
	canvas addMorph: (aGeoDSLObject asMorph) 
			
		! !

!GeoDSLDrawing methodsFor: 'interface' stamp: 'hk 1/27/2014 16:42'!
add: aMorphClass name: aString size: aSize at: aPoint 
	^self add: aMorphClass name: aString size: aSize at: aPoint bearing: 0 label: ''

! !

!GeoDSLDrawing methodsFor: 'interface' stamp: 'hk 1/28/2014 16:41'!
add: aMorphClass name: aString size: aSize at: aPoint bearing: aRadian label:  aString2
	"add a non-polygon object. my signature resembles the DSL grammar"
	 |o|
	o := (GeoDSLObject new)
			morphClass: aMorphClass asSymbol;
			name: aString;
			size: aSize;
			location: aPoint;
			bearing: aRadian;
			label: aString2;
			yourself.                  
	self addToObjectDict: o.
	self resetZoom.	
	canvas addMorph: (o asMorph) 
			
		! !

!GeoDSLDrawing methodsFor: 'interface' stamp: 'hk 1/28/2014 16:48'!
add: aMorphClass name: aString vertices: anArray 
 	self add: aMorphClass name: aString vertices: anArray bearing: 0 label:  ''
		! !

!GeoDSLDrawing methodsFor: 'interface' stamp: 'hk 1/28/2014 16:40'!
add: aMorphClass name: aString vertices: anArray bearing: aRadian label:  aString2
	"add a polygon. my signature resembles the DSL grammar"
	 |o|
	o := (GeoDSLPathshape vertices: anArray)
			morphClass: aMorphClass asSymbol;
			name: aString;
			bearing: aRadian;
			label: aString2;
			yourself.                  
	self addToObjectDict: o.
	self resetZoom.	
	canvas addMorph: (o asMorph) 
			
		! !

!GeoDSLDrawing methodsFor: 'parsing' stamp: 'hk 1/20/2014 19:56'!
addToObjectDict: aGeoDSLObject 
	(objectDict includesKey:  aGeoDSLObject name1)
		ifTrue: [ExampleBuilderMorph new abort:  'double names in GeoDSL' ].
	objectDict add: aGeoDSLObject name1 -> aGeoDSLObject.
	self mergeRealBounds: aGeoDSLObject realBounds.
	^ aGeoDSLObject! !

!GeoDSLDrawing methodsFor: 'accessing' stamp: 'hk 1/20/2014 14:38'!
canvas
	^ canvas! !

!GeoDSLDrawing methodsFor: 'parsing' stamp: 'hk 1/27/2014 13:04'!
createAllMorphsWithin: aPoint 
	screenBounds := 0 @ 0 extent: aPoint.
	self resetZoom.
	canvas addAllMorphs: (objectDict values collect: [:e | e asMorph ])  ! !

!GeoDSLDrawing methodsFor: 'initialize-release' stamp: 'hk 1/27/2014 13:52'!
initialize: aString 
	title := aString.
	canvas := PasteUpMorph new. 
	objectDict := Dictionary new

! !

!GeoDSLDrawing methodsFor: 'private' stamp: 'hk 1/26/2014 17:46'!
mergeRealBounds: aRectangle 
	realBounds ifNil: [ realBounds := aRectangle]
	ifNotNil: [realBounds := realBounds quickMerge: aRectangle]
	! !

!GeoDSLDrawing methodsFor: 'interface' stamp: 'hk 1/29/2014 13:10'!
moveObject: aString To: aPoint bearing: degrees 
	(objectDict  at: aString) moveTo: aPoint bearing: degrees degreesToRadians zoom: zoom! !

!GeoDSLDrawing methodsFor: 'interface' stamp: 'hk 1/23/2014 16:57'!
moveObject: aString by: aNumber left: degrees 
	self moveObject: aString by: aNumber right: degrees negated! !

!GeoDSLDrawing methodsFor: 'interface' stamp: 'hk 1/23/2014 16:24'!
moveObject: aString by: aNumber right: degrees 
	(objectDict  at: aString) moveBy: aNumber right: degrees degreesToRadians zoom: zoom! !

!GeoDSLDrawing methodsFor: 'private' stamp: 'hk 1/26/2014 18:31'!
originalZoom
	^ (screenBounds width / realBounds width)
					min: (screenBounds height / realBounds height)
	! !

!GeoDSLDrawing methodsFor: 'interface' stamp: 'hk 1/27/2014 17:37'!
removeObjectNamed: aString 
	"my signature resembles the DSL grammar"
	 |o|
	o := objectDict at: aString ifAbsent: [^'not found' ].                  
	canvas removeMorph: o morph.
	objectDict removeKey: aString 
			
		! !

!GeoDSLDrawing methodsFor: 'actions' stamp: 'hk 1/26/2014 17:49'!
resetZoom
	self zoom: self originalZoom! !

!GeoDSLDrawing methodsFor: 'accessing' stamp: 'hk 1/27/2014 14:50'!
screenBounds
	^ screenBounds ! !

!GeoDSLDrawing methodsFor: 'private' stamp: 'hk 1/21/2014 14:18'!
setZoomTranslation
	objectDict valuesDo: [:o | o zoom: zoom translate: translation]! !

!GeoDSLDrawing methodsFor: 'accessing' stamp: 'hk 1/27/2014 11:49'!
title
	^ title! !

!GeoDSLDrawing methodsFor: 'private' stamp: 'hk 1/21/2014 16:46'!
translationWith: aZoom
	^ (aZoom * realBounds origin) rounded negated  + canvas bounds origin.

		! !

!GeoDSLDrawing methodsFor: 'accessing' stamp: 'hk 1/29/2014 14:15'!
zoom
	^ zoom ! !

!GeoDSLDrawing methodsFor: 'private' stamp: 'hk 1/23/2014 13:07'!
zoom: aZoom
	zoom := aZoom.
	translation := self translationWith: aZoom.
	"zoom all my objects"
	self setZoomTranslation! !

!GeoDSLDrawing methodsFor: 'actions' stamp: 'hk 1/21/2014 16:26'!
zoomIn
	self zoom: zoom * 1.5! !

!GeoDSLDrawing methodsFor: 'actions' stamp: 'hk 1/21/2014 16:27'!
zoomOut
	self zoom: zoom * 0.5! !

Object subclass: #GeoDSLModel
	instanceVariableNames: 'drawing window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLModel commentStamp: '<historical>' prior: 0!
A GeoDSLModel works with GeoDSLGrammar and GeoDSLCompiler

Instance Variables
	drawing:		<GeoDSLDrawing>
	window:		<StandardWindow>
!

GeoDSLModel subclass: #GeoDSLExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!GeoDSLExample commentStamp: '<historical>' prior: 0!
A GeoDSLExample holds som simple examples for the GeoDSL

!

!GeoDSLExample class methodsFor: 'simple examples' stamp: 'hk 1/28/2014 16:30'!
example
	"self example"
	|x|
	x := GeoDSLExample new createFrom: GeoDSLExample geoSpec0 background: 'Nbgring.jpg'.
	x drawing add: #GeoDSLCar  name: 'test1' size: 66@20 at: 100@200 bearing: 90 label: 'my Ferrari'. 

	[35 timesRepeat: [ (Delay forMilliseconds: 20) wait.  x drawing  moveObject: 'test1' by:  2 right: 1 ]] fork.
	[360 timesRepeat: [ (Delay forMilliseconds: 10) wait.  x drawing  moveObject: 'a1' by:  1.75 left: 1 ]] fork.

	[ (Delay forSeconds: 4 )wait.  x drawing removeObjectNamed: 'test1' ] fork! !

!GeoDSLExample class methodsFor: 'simple examples' stamp: 'hk 1/20/2014 21:18'!
geoSpec
		"GeoDSLExample new createFrom: self geoSpec"
^' displayIn: myGraphics size: 1100@550

		(polygon: bla [0@0 150@0 150@100 0@100] label: border )
		(BorderedMorph  lane1 size: 60@20 at: 50@50  bearing: 90 label: spur1)
		
	   	(BorderedMorph  lane2 size: 60@20 at: 75@50 bearing: 90 label: spur2 ) 
	   	(BorderedMorph  lane3 size: 60@20 at: 100@50 bearing: 90 label: spur3 ) 
		(BorderedMorph  agv1 size: 20@8 at: 500@150 bearing:  10) 
		(BorderedMorph  agv2 size: 20@8at: 500@180 bearing: 60 )
		
		(polyline: blb [200@300 250@320 300@350 230@370] label: line )		
		(CircleMorph  c1 size: 200@100 at: 1000@500 label: agv2 )
		(EllipseMorph  c2 size: 400@200 at: 400@300 bearing:  45 label: agv1)
'! !

!GeoDSLExample class methodsFor: 'simple examples' stamp: 'hk 1/27/2014 16:26'!
geoSpec0
		"GeoDSLExample new createFrom: self geoSpec0"
	^ '
	displayIn: myGraphics size: 1000@500
		(BorderedMorph  lane1 size: 60@20 at: 300@100  bearing: 90 label: spur1)
	   	(BorderedMorph  lane2 size: 60@20 at: 375@100  )
		
		(BorderedMorph  agv1 size: 20@8 at: 500@150 bearing:  10)
		(BorderedMorph  agv2 size: 20@8at: 500@180 bearing: 60 )
		
		(CircleMorph  c1 size: 200@200 at: 400@300 bearing: 1  label: the_circle)
		(GeoDSLCar  a1 size: 32@10 at: 500@300 bearing: 90  label: car1)
		(EllipseMorph  c2 size:  200@100 at: 400@300 bearing: 135 label: the_ellipse )
		
		(polygon: bla [200@200 250@220 300@250 230@270] label: border )
		(polyline: blb [200@300 250@320 300@350 230@370] label: line )		
'! !

!GeoDSLExample class methodsFor: 'simple examples' stamp: 'hk 1/28/2014 20:10'!
geoSpecTrafficSimulation
		"GeoDSLExample new createFrom: self geoSpecTrafficSimulation"
^' displayIn: myGraphics size: 1100@550
		(BorderedMorph  corner1 size: 10@10 at: 4700@900 )	
	   	(BorderedMorph  corner2 size: 10@10 at: 5825@1605 ) 
'! !

!GeoDSLModel methodsFor: 'initialize-release' stamp: 'hk 1/27/2014 14:55'!
createFrom: aSpec 
	self createFrom: aSpec background: nil! !

!GeoDSLModel methodsFor: 'initialize-release' stamp: 'hk 1/27/2014 17:24'!
createFrom: aSpec background: anImageFileOrNil 
	"comment stating purpose of message"
 
	drawing := GeoDSLCompiler compile: aSpec .
	window := StandardWindow labelled: drawing title.
	self decorateWindowWith: anImageFileOrNil .
	window  openInWorld.	! !

!GeoDSLModel methodsFor: 'as yet unclassified' stamp: 'hk 1/27/2014 17:23'!
decorateWindowWith: anImageFileOrNil
	| tools dock |
	tools := window newToolbar: 
				{window
					newButtonFor: drawing
					getState: nil
					action: #zoomIn
					arguments: nil
					getEnabled: nil
					label: 'zoom in'
					help: 'zoom in by a certain amount'. 
				window
					newButtonFor: drawing
					getState: nil
					action: #zoomOut
					arguments: nil
					getEnabled: nil
					label: 'zoom out'
					help: 'zoom out by a certain amount'.
				window
					newButtonFor: drawing
					getState: nil
					action: #resetZoom
					arguments: nil
					getEnabled: nil
					label: 'reset zoom'
					help: 'zoom to original'}.
	dock := window newToolDockingBar.
	dock addMorph: tools.
	window
		addMorph: dock
		fullFrame: ((0 @ 0 corner: 1 @ 0.5) asLayoutFrame bottomOffset: dock minExtent y). 
	window addMorph: drawing canvas fullFrame: ((0@0 corner: 1@1) asLayoutFrame topOffset: dock minExtent y).
	anImageFileOrNil ifNotNil: 
		[drawing canvas backgroundMorph: ((Form fromFileNamed: anImageFileOrNil) scaledToSize: drawing screenBounds extent) asMorph].
	window themeChanged! !

!GeoDSLModel methodsFor: 'accessing' stamp: 'hk 1/23/2014 14:41'!
drawing
	^ drawing! !

GeoDSLModel subclass: #TrafficSimulation
	instanceVariableNames: 'cars road sleepingDrivers tick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!TrafficSimulation commentStamp: '<historical>' prior: 0!
A TrafficSimulation is an example for the GeoDSL.
It demonstrates the traffic phase transition from free flow to congestion when the car density becomes too high for a certain velocity. 

Instance Variables
	cars:				<OrderedCollection of TSCar>
	road:				<TSRoad>
	sleepingDrivers:	<Boolean>			- reaction delay from stop to go
	tick:				<Integer>			- simulation tick distance in milliseconds
											  
			!

!TrafficSimulation class methodsFor: 'as yet unclassified' stamp: 'hk 1/28/2014 16:44'!
newOn: aTSRoad with: noOfCars
 	^(self new)
		road: aTSRoad;
		cars: noOfCars;
		open
		! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/30/2014 15:15'!
carAt: index 
	"modulo - assuming a circular list"  
	^cars at: ((index - 1 + cars size) \\ cars size) + 1! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/29/2014 11:32'!
cars: aNumber 
	1 to: aNumber do: 
		[:i | |c|
		c := TSCar newOn: self.
		c sleepingDriver: self sleepingDrivers.
		c name: 'c', i asString.
		c label: 'c', i asString.
		c carIndex: i.
		cars addLast: c]! !

!TrafficSimulation methodsFor: 'initialize-release' stamp: 'hk 1/28/2014 20:44'!
initialize 
	sleepingDrivers := false.
	cars := OrderedCollection new.
	tick := 100.! !

!TrafficSimulation methodsFor: 'simulation' stamp: 'hk 1/30/2014 15:35'!
next
"	(Delay forMilliseconds: tick) wait.
"	cars do: [ :e | e next ]! !

!TrafficSimulation methodsFor: 'simulation' stamp: 'hk 1/30/2014 13:17'!
open 
		
	self createFrom: GeoDSLExample geoSpecTrafficSimulation background: 'Nbgring.jpg'.
	drawing add:  road.
	cars do: [ :e | e location: (5000@950). drawing add: e ]

! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/28/2014 15:56'!
road
	^ road! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/28/2014 16:06'!
road: aTSRoad 
	road := aTSRoad! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/28/2014 15:56'!
sleepingDrivers
	^ sleepingDrivers! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/28/2014 16:03'!
sleepingDrivers: aBoolean 
	sleepingDrivers := aBoolean! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/28/2014 21:02'!
tick
	^ tick! !

Object subclass: #GeoDSLObject
	instanceVariableNames: 'morphClass name label morph location size bearing screenLocation screenSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLObject commentStamp: '<historical>' prior: 0!
A GeoDSLObject stores the real world information of an object in a GeoDSL application.
In addition it stores all information that is needed by the GeoDSL parser to create its morph.

Instance Variables
	label:				<String>
	morphClass:		<ClassName>
	name:				<String>
	morph:				<Morph>
	screenLocation:	<Point>			center of bounds
	screenSize:		<Point>			extent of bounds


label
	- the displayed name of the object

morphClass
	- needed for creation of the morph (GeoDSLOther>>asMorph)

name
	- for programmed reference
!

!GeoDSLObject methodsFor: 'private' stamp: 'hk 1/27/2014 13:01'!
asBasicMorph
	"answer the bare morph that I describe"
	|m|
	m := (Smalltalk at: morphClass) newBounds: (0@0 extent: screenSize ).
	m center: screenLocation.
	self attribute: m.
	^ m! !

!GeoDSLObject methodsFor: 'converting' stamp: 'hk 1/27/2014 13:12'!
asMorph
	^morph := self asTransformationMorph! !

!GeoDSLObject methodsFor: 'private' stamp: 'hk 1/27/2014 13:12'!
asTransformationMorph
	"wrap the bare morph by ist transformation"
	|m|
	m := TransformationMorph new asFlexOf: self asBasicMorph.
	m angle: bearing.
	m name: name.
	^ m! !

!GeoDSLObject methodsFor: 'private' stamp: 'hk 1/23/2014 10:28'!
attribute: aMorph
	aMorph name:  name.
	aMorph addMorph: 
		(label asTextMorph position: aMorph position)
	! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/21/2014 17:33'!
bearing: aNumber
	bearing := aNumber! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/19/2014 19:26'!
label: anObject
	label := anObject! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/29/2014 15:52'!
location
	^location! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/21/2014 17:33'!
location: aPoint
	location := aPoint! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/27/2014 17:40'!
morph
	^morph ! !

!GeoDSLObject methodsFor: 'parsing-interface' stamp: 'hk 1/19/2014 19:31'!
morphClass: aClassName
	morphClass := aClassName! !

!GeoDSLObject methodsFor: 'parsing-interface' stamp: 'hk 1/29/2014 12:57'!
moveBy: aNumber right: aRadian zoom: aZoom
	"move and turn differentially"
	| delta |
	delta := Point radius: aNumber theta: bearing negated.
	location := location + delta.
	bearing := bearing - aRadian.
	bearing := bearing \\ (2 * Float pi).			"keep bearing within 2 pi"
	morph position:  (morph position) + (delta * aZoom).
"	screenLocation := morph center.			not sure that we need this"
	morph angle: bearing

! !

!GeoDSLObject methodsFor: 'parsing-interface' stamp: 'hk 1/29/2014 13:07'!
moveTo: aPoint bearing: aRadian zoom: aZoom
	"move and turn absolutely"
	| delta |
	delta := aPoint - location.
	location := aPoint.
	bearing := aRadian.
	morph position:  (morph position) + (delta * aZoom).
"	screenLocation := morph center.			not sure that we need this"
	morph angle: bearing

! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/20/2014 17:00'!
name1
	^name ! !

!GeoDSLObject methodsFor: 'private' stamp: 'hk 1/20/2014 13:57'!
name: aString
	name := aString! !

!GeoDSLObject methodsFor: 'zoom & translation' stamp: 'hk 1/21/2014 17:34'!
realBounds
	^ location - (size / 2) extent: size ! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/21/2014 17:33'!
size: aPoint
	size := aPoint! !

!GeoDSLObject methodsFor: 'zoom & translation' stamp: 'hk 1/27/2014 18:44'!
zoom: aNumber translate: aPoint 
	screenLocation := (location * aNumber + aPoint) rounded.
	screenSize := (size * aNumber) rounded.
	morph ifNotNil: [self zoomMorph]! !

!GeoDSLObject methodsFor: 'zoom & translation' stamp: 'hk 1/27/2014 13:18'!
zoomMorph
	morph bounds: (self asTransformationMorph bounds).
	morph center: screenLocation! !

GeoDSLObject subclass: #GeoDSLPathshape
	instanceVariableNames: 'points closed screenPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLPathshape commentStamp: '<historical>' prior: 0!
A GeoDSLPathshape represents polygons and polylines.

Instance Variables
	points:			<Array>
	screenPoints:	<Array>
	closed:			<Boolean>

closed
	- true for Polygon, false for Polyline

points
	- my real world points
!

!GeoDSLPathshape class methodsFor: 'instance creation' stamp: 'hk 1/21/2014 17:31'!
vertices: anArrayOfPoints 

	^self new initWithPoints: anArrayOfPoints! !

!GeoDSLPathshape methodsFor: 'converting' stamp: 'hk 1/27/2014 17:50'!
asBasicMorph
	"answer the bare morph that I describe"
	|m|
	m := PolygonMorph
				vertices: screenPoints
				color: Color transparent
				borderWidth: 1
				borderColor: Color black.
	closed ifTrue: [m makeClosed] ifFalse: [ m makeOpen  ].
	self attribute: m.
	^ m! !

!GeoDSLPathshape methodsFor: 'parsing-interface' stamp: 'hk 1/19/2014 19:26'!
closed: aBoolean
	closed := aBoolean! !

!GeoDSLPathshape methodsFor: 'initialize-release' stamp: 'hk 1/21/2014 17:31'!
initWithPoints: anArrayOfPoints
	points := anArrayOfPoints.
	size := self realBounds extent.
	location := self realBounds  center.! !

!GeoDSLPathshape methodsFor: 'accessing' stamp: 'hk 1/20/2014 17:18'!
realBounds
	^(PathShape  vertices: points ) bounds! !

!GeoDSLPathshape methodsFor: 'zoom & translation' stamp: 'hk 1/23/2014 10:40'!
zoom: aNumber translate: aPoint 
	screenPoints := points collect: [ :e | e * aNumber + aPoint ].
	super zoom: aNumber translate: aPoint ! !

GeoDSLPathshape subclass: #TSRoad
	instanceVariableNames: 'roadMaxV'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!TSRoad commentStamp: '<historical>' prior: 0!
A TSRoad is the road in the TrafficSimulation.

Instance Variables
	roadMaxV:		<Array of Number|nil>		- the maxV signs (same size as points)

!

!TSRoad class methodsFor: 'roads' stamp: 'hk 1/28/2014 17:07'!
pointsRoad1
	"self road1"  "almost an oval using 64 points"
 ^{	Point x: 5000 y: 1000 .
	Point x: 5050 y: 1000 .
	Point x: 5100 y: 1000 .
	Point x: 5150 y: 1000 .
	Point x: 5200 y: 1000 .
	Point x: 5250 y: 1000 .
	Point x: 5300 y: 1000 .
	Point x: 5350 y: 1000 .
	Point x: 5400 y: 1000 .
	Point x: 5450 y: 1000 .
	Point x: 5500 y: 1000 .
	Point x: 5550 y: 1000 .
	Point x: 5590 y: 1010 .
	Point x: 5630 y: 1020 .
	Point x: 5660 y: 1040 .
	Point x: 5690 y: 1060 .
	Point x: 5710 y: 1090 .
	Point x: 5730 y: 1120 .
	Point x: 5740 y: 1160 .
	Point x: 5750 y: 1200 .
	Point x: 5750 y: 1250 .
	Point x: 5750 y: 1300 .
	Point x: 5740 y: 1340 .
	Point x: 5730 y: 1380 .
	Point x: 5710 y: 1410 .
	Point x: 5690 y: 1440 .
	Point x: 5660 y: 1460 .
	Point x: 5630 y: 1480 .
	Point x: 5590 y: 1490 .
	Point x: 5550 y: 1500 .
	Point x: 5500 y: 1500 .
	Point x: 5450 y: 1500 .
	Point x: 5400 y: 1500 .
	Point x: 5350 y: 1500 .
	Point x: 5300 y: 1490 .
	Point x: 5250 y: 1480 .
	Point x: 5200 y: 1470 .
	Point x: 5150 y: 1460 .
	Point x: 5100 y: 1450 .
	Point x: 5050 y: 1440 .
	Point x: 5000 y: 1430 .
	Point x: 4960 y: 1420 .
	Point x: 4920 y: 1410 .
	Point x: 4890 y: 1400 .
	Point x: 4860 y: 1390 .
	Point x: 4840 y: 1380 .
	Point x: 4820 y: 1360 .
	Point x: 4810 y: 1340 .
	Point x: 4800 y: 1310 .
	Point x: 4800 y: 1290 .
	Point x: 4810 y: 1260 .
	Point x: 4820 y: 1230 .
	Point x: 4840 y: 1190 .
	Point x: 4860 y: 1150 .
	Point x: 4880 y: 1120 .
	Point x: 4900 y: 1090 .
	Point x: 4920 y: 1070 .
	Point x: 4930 y: 1050 .
	Point x: 4940 y: 1040 .
	Point x: 4950 y: 1030 .
	Point x: 4960 y: 1020 .
	Point x: 4970 y: 1012 .
	Point x: 4980 y: 1006 .
	Point x: 4990 y: 1002 
}! !

!TSRoad class methodsFor: 'instance creation' stamp: 'hk 1/28/2014 16:54'!
road1
	^(self new)
		initWithPoints:  self pointsRoad1;
		roadMaxV: self speedLimits1 ;
		name: 'road1' 
		! !

!TSRoad class methodsFor: 'roads' stamp: 'hk 1/28/2014 15:53'!
speedLimits1
	"self speedLimits1"  "speed limits for road1 0 = no change, 1000 = no limit"
 ^(IntegerArray ofSize: 64)
	at: 1 put: 1000;
	at: 14 put: 120;
	at: 28 put: 1000;
	at: 50 put: 80;
	yourself
	! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/30/2014 13:42'!
index: index behind: otherIndex 
	"i am only behind if otherIndex is not greater than half the road"
	^ (otherIndex - index + points size \\ points size) < (points size / 2)! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/29/2014 14:49'!
initialPosition 
	^self roadPointAt: 1! !

!TSRoad methodsFor: 'initialize-release' stamp: 'hk 1/28/2014 17:11'!
initialize 
	"I must be initialized carefully since I am used directly in GeoDSLDrawing"
	closed := true.
	bearing := 0.
	label := ''.
	morphClass := #PolygonMorph! !

!TSRoad methodsFor: 'accessing' stamp: 'hk 1/28/2014 16:53'!
name: aString
	name := aString ! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/30/2014 14:32'!
nextIndexOf: index 
	"modulo"
	^ (index \\ points size) + 1 ! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/30/2014 11:43'!
nextPositionFor: distance From: aPoint at: index 

	| nextP nextI r |
	nextI := self nextIndexOf: index.
	nextP :=  points at: nextI. 
	r := (nextP - aPoint) r. 
	(r > distance ) ifTrue: [ ^self roadPoint: aPoint + ((nextP - aPoint) * distance / r) at: index].
	(r < distance ) ifTrue: [^self nextPositionFor: distance-r From: nextP at: nextI ] .
	(r = distance ) ifTrue: [ ^self roadPointAt: nextI ]
	! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/28/2014 13:34'!
pointFrom: aNextPoint distance: aNumber 
	"answer aNextPoint on myself"! !

!TSRoad methodsFor: 'accessing' stamp: 'hk 1/28/2014 16:18'!
roadMaxV: anIntegerArray
	roadMaxV := anIntegerArray! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/30/2014 12:31'!
roadPoint: aPoint at: index 
	| nextIndex |
	nextIndex := self nextIndexOf: index.
	^RoadPoint from: aPoint at: index bearing:  ((points at: nextIndex) - aPoint ) theta negated! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/29/2014 15:51'!
roadPointAt: index 
	^self roadPoint: (points at: index) at: index
! !

GeoDSLObject subclass: #TSCar
	instanceVariableNames: 'a maxV v ts sleepingDriver carIndex roadIndex minDistance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!TSCar commentStamp: '<historical>' prior: 0!
A TSCar is a car in the TrafficSimulation.

Instance Variables
	a:					<Number>			- acceleration in m/s^2
	minDistance:		<Number>			- minimal breaking distance in traffic
	maxV:				<Number>			- of the car
	ts:					<TrafficSimulation> 
	v:					<Number>			- actual velocity of the car
	sleepingDriver:		<Boolean>			- reaction delay from stop to go
	carIndex:			<Integer>			- in the collection of cars
	roadIndex:			<Integer>			- in the road. 0 = offRoad
!

!TSCar class methodsFor: 'as yet unclassified' stamp: 'hk 1/28/2014 12:56'!
newOn: aTrafficSimulation 
	^(self new) ts: aTrafficSimulation ! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/30/2014 12:48'!
carInFront
	^ts carAt: carIndex - 1! !

!TSCar methodsFor: 'accessing' stamp: 'hk 1/29/2014 11:32'!
carIndex:  anInteger
	carIndex := anInteger! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/30/2014 15:32'!
distanceToGo
	"answer the distance to go. if possible i am accelerated"
	| fD dv |
	fD := 0 max: (self frontDistance - (v / 2) - minDistance) .		"the distance rule"
	fD < (self distanceWith: v) ifTrue: [v := self velocityFor: fD. ^ fD].  "slow down"
	dv := self velocityGainIn: fD - (self distanceWith: v).
	v := v + dv.															"accelerate"
	^ self distanceWith: v + (dv / 2)! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/29/2014 11:55'!
distanceWith: aVelocity
	^ 1000 * aVelocity  / ts tick! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/30/2014 14:45'!
frontDistance
	"we can safely neglect curvatures"
	self carInFront onroad ifFalse: [^ self distanceWith: maxV ].
	(ts road index: roadIndex  behind: self carInFront roadIndex ) 
		ifTrue: [^(self carInFront location - location) r ]
		ifFalse: [ ^ self distanceWith: maxV ]
! !

!TSCar methodsFor: 'initialize-release' stamp: 'hk 1/30/2014 12:32'!
initialize
	a := 2.
	maxV := 50.
	sleepingDriver := false.
	minDistance := 80.
	v := 0.
	roadIndex := 0.  "offroad"
	"init super instance vars"
	morphClass := #GeoDSLCar.
	size := 64 @ 16.
	name := ''.
	label := ''.
	bearing := 0.! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/30/2014 14:54'!
move
	"advance me according to my v and room for acceleration"
	| p | 
	self frontDistance  > minDistance ifTrue: 
		[ p := ts road nextPositionFor: self distanceToGo  From: location  at: roadIndex .
		 self moveTo: p ].! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/29/2014 17:57'!
moveTo: aRoadPoint
	self moveTo: aRoadPoint  bearing: aRoadPoint bearing zoom:  ts drawing zoom .  
	roadIndex := aRoadPoint index ! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/29/2014 17:53'!
next
	self onroad ifFalse: [ ^self putOnRoad ].
	self move.! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/29/2014 17:42'!
onroad
	^(roadIndex = 0) not! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/30/2014 12:56'!
putOnRoad
	"put me at the road initial position if empty. do nothing if occupied"
	| p | 
	p := ts road initialPosition.
	"start with first car"  
	carIndex = 1 ifTrue: [ ^self moveTo: p].
	self carInFront onroad ifFalse: [ ^self ].
	self carInFront location = p ifFalse: [ self moveTo: p ].
! !

!TSCar methodsFor: 'accessing' stamp: 'hk 1/30/2014 13:41'!
roadIndex
	^roadIndex! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/30/2014 15:23'!
safetyDistanceWith: aVelocity
	"the rule"
	^ v / 2! !

!TSCar methodsFor: 'accessing' stamp: 'hk 1/28/2014 16:02'!
sleepingDriver: aBoolean
	sleepingDriver := aBoolean! !

!TSCar methodsFor: 'accessing' stamp: 'hk 1/28/2014 12:56'!
ts: aTrafficSimulation
	ts := aTrafficSimulation! !

!TSCar methodsFor: 'private' stamp: 'hk 1/30/2014 12:24'!
velocityFor: aDistance 
	"dv = dx / 1"
	^ aDistance! !

!TSCar methodsFor: 'private' stamp: 'hk 1/30/2014 12:15'!
velocityGainIn: aDistance 
	"dv = a * dt"
	^ a * ts tick /1000! !

Point subclass: #RoadPoint
	instanceVariableNames: 'bearing index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!RoadPoint commentStamp: '<historical>' prior: 0!
A NextPoint is a point and a direction (bearing).

Instance Variables
	bearing:		<Number>		- of the next point (index + 1) - in radians
	index: 			<Integer>		- of the reference point of the polygon array
!

!RoadPoint class methodsFor: 'as yet unclassified' stamp: 'hk 1/29/2014 17:50'!
from: aPoint at: index bearing:  radians
	^(self x: aPoint x y: aPoint y)
		index: index;
		bearing: radians! !

!RoadPoint methodsFor: 'accessing' stamp: 'hk 1/28/2014 13:21'!
bearing
	^ bearing! !

!RoadPoint methodsFor: 'accessing' stamp: 'hk 1/28/2014 13:22'!
bearing: aRadian
	bearing := aRadian! !

!RoadPoint methodsFor: 'accessing' stamp: 'hk 1/28/2014 13:37'!
index
	^ index! !

!RoadPoint methodsFor: 'accessing' stamp: 'hk 1/28/2014 13:37'!
index: anInteger
	index := anInteger! !
